<div style="text-align: center; display: grid; grid-template-columns: 1fr 1fr;">
<div> <!-- Left pane -->
<!-- Title -->

## Hardware

- Graphics card(s)
    - 3D accelerator
    - Video RAM
    - VBIOS
- Display controller(s)
- Monitor(s)
    - EDID

</div>
<div> <!-- Right pane -->
<!-- Title -->

![Image.](media/overview.svg) <!-- .element: style="width: 50%;" -->

</div>

Note:
Starting with: Your hardware.

In the context of graphics, hardware usually is referring to your graphics card, or GPU for short. This can be something like
an "NVIDIA RTX 2070 SUPER", "AMD Radeon RX 6700 XT", or whatever integrated solution your device has.

GPUs are pretty complicated beasts, but for today we'll only talk about them on a very high level.
GPUs tend to consist of some sort of 3D accelerator. This is essentially just a massive pool of highly specialized CPU cores.
They also have Video RAM for storing things like game textures, geometry, and the ultimate output that is sent to the screen.
There's also the VBIOS, which is essentially the GPU's firmware.

However, there are a few more pieces to the puzzle. There are also display controllers, which provide the video outputs. These
are usually found on the GPU itself, but not always.

There's also of course your monitors, which are not only the ultimate destination, but are also important because they provide information
about themselves using a protocol called EDID, or Extended Display Identification Data.

[comment]: # (!!!) <!--------------------------------------------------------->
